                                        ;
include C:\MASM32\INCLUDE\windows.inc
include C:\MASM32\INCLUDE\kernel32.inc
include C:\MASM32\INCLUDE\comdlg32.inc
include C:\MASM32\INCLUDE\comctl32.inc
include C:\MASM32\INCLUDE\gdi32.inc
include C:\MASM32\INCLUDE\user32.inc
;include C:\MASM32\INCLUDE\shell32.inc
;include C:\MASM32\INCLUDE\advapi32.inc
include C:\MASM32\INCLUDE\winmm.inc
include C:\MASM32\INCLUDE\fpu.inc
include C:\masm32\m32lib\masm32.inc

includelib C:\MASM32\LIB\kernel32.lib
includelib C:\MASM32\LIB\comdlg32.lib
includelib C:\MASM32\LIB\comctl32.lib
includelib C:\MASM32\LIB\gdi32.lib
includelib C:\MASM32\LIB\user32.lib
;includelib C:\MASM32\LIB\shell32.lib
;includelib C:\MASM32\LIB\advapi32.lib
includelib C:\MASM32\LIB\winmm.lib
includelib C:\MASM32\LIB\fpu.lib
includelib C:\masm32\m32lib\masm32.lib

DlgProc         PROTO :DWORD,:DWORD,:DWORD,:DWORD
GrwProc         PROTO :DWORD,:DWORD,:DWORD,:DWORD

;-------macro's--------------------------
szText  macro Name,Text:VARARG          ;
        jmp     @F                      ;
        Name db Text,0                  ;
        @@:                             ;
        endm                            ;

LOWORD  macro   bigword                 ; Retrieves the low word from double word argument
        mov     eax,bigword             ;
        and     eax,0FFFFh              ; Set to low word
        endm                            ;

HIWORD  macro   bigword                 ; Retrieves the high word from double word argument
        mov     ebx,bigword             ;
        shr     ebx,16                  ; Shift 16 for high word to set to high word
        endm                            ;

m2m     macro   Var1,Var2               ;
        push    Var2                    ;
        pop     Var1                    ;
        endm                            ;

CHKANS  macro                           ; ஢塞 ⢥ SB functions
        .if eax != MMSYSERR_NOERROR     ; error
            invoke  dwtoa, eax, addr temp
            invoke  SendMessage, hDlg,WM_SETTEXT,0,addr szErN
            xor     eax, eax            ;  訡
            ret                         ; 蠥
        .endif                          ;
        endm                            ;

.const
MUTEX_ALL_ACCESS    equ 1F0001h         ;
MAXSIZE         equ 260                 ;
Format          equ WAVE_FORMAT_PCM     ;
FSample         equ 44100               ;  롮ન
Qfft            equ 1024                ; - 롮ப
cxSize          equ 1032                ; ࠧ   ਧ⠫
cySize          equ 165                 ; ࠧ   ⨪
amplup          equ 255                 ; 孥 祭 ADC/8
Bitpersample    equ 8                   ;
Channels        equ 1                   ;

.data
AppName         db "AudioMonitor",0     ;
GraphClass      db "SimpleWin",0        ;
font1           db "decorative",0       ;
;----------------------------------------
FreqInfo        db "    Frequency: "    ;
frtemp          db 16 dup (0)           ;
empstr          db 4 dup (" ")          ;
; 饭  訡   ⮫쪮-------
szNoSB          db "    No SB in system!", 0
szSuSB          db "    No such SB number in system!", 0
carrSB          db "    SB #: "         ;
sbnum           db "1", 0               ;  SB  ⥬
szErN           db "    Error #: "      ;  CHKANS
temp            db 16 dup (0)           ;

align   4                               ;
sumbuff1        dd cxSize dup (156)     ; 1 ⥫ 
sumbuff2        dd cxSize dup (156)     ; 2 ⥫ 
buffl           dd 0                    ; 0/1 䫠  ࠬ

WAVEFILEHDR     STRUCT                  ;
                DWORD   0               ; "RIFF"
rFormatSize     DWORD   0               ; ࠧ 䠩-8 (wDataSize+36)
                DWORD   0               ; "WAVE"
                DWORD   0               ; "fmt "
                DWORD   0               ; 16 - ᬥ. data/ ᫥.᫮
                WORD    0               ; 1?
nChannels       WORD    0               ; 1/2
nSamplesPerSec  DWORD   0               ; 8000/11025/22050
nAvgBytesPerSec DWORD   0               ; nBlockAlign*nSamplesPerSec
nBlockAlign     WORD    0               ; nChannels*wBitsPerSample/8
wBitsPerSample  WORD    0               ; 8/16/24
                DWORD   0               ; "data"
wDataSize       DWORD   0               ; ࠧ 䠩-44 (wDataSize)
WAVEFILEHDR     ENDS                    ;

wfh WAVEFILEHDR <"FFIR",0,"EVAW"," tmf",16,1,1,11025,0,0,8,"atad",0>
szFileName      db MAXSIZE dup (0)      ; ᥣ 7 + 6 = 13 
reclbl          db " RECORD ", 0        ;
strtlbl         db " START  ", 0        ;
stoplbl         db "  STOP  ", 0        ;
reslbl          db " RESET  ", 0        ;

sbID            dd 0                    ; .⥪.SB
hwavwr          dd 0                    ; handle .wav 䠩 
store           dd offset InBuffer0     ; 㪠. in  SBlaster'
samplfr         dd FSample              ;  롮ન
samples         dd Qfft                 ; - 롮ப fft
power           dd 0                    ; ⥯   samples
itwo            dd 2                    ; 2.0  ⢥ ⠭

sample          dq 0                    ; 1/FSample - ࢠ 롮ન
time            dq 0                    ; ६  sample'
mag             dq 0                    ; ࠭ १
max             dq 0                    ; ࠭ १
cyScale         dq 32.0                 ; ⥫  ⨪
mScale          dq 96.0                 ; ⥫  ⨪
TWO_PI          dq 0                    ; 2pi

.data?
wc              WNDCLASSEX      <>      ;
systi           SYSTEMTIME      <>      ; system time parameters
wh0             WAVEHDR         <>      ; for buffer1 handle
wh1             WAVEHDR         <>      ; for buffer2 handle
ti              TOOLINFO        <>      ;
wfe             WAVEFORMATEX    <>      ;

align   4                               ;
InBuffer0       db Qfft dup (?)         ; ᬥ 
InBuffer1       db Qfft dup (?)         ; Sound Blaster'
larray          dd 2*cxSize dup (?)     ; ᨢ  POINT

hred            dd ?                    ;
hgreen          dd ?                    ;
hblue           dd ?                    ;
hfont           dd ?                    ; 室 䮭
hfont1          dd ?                    ; decorative
hInst           dd ?                    ; handle ᭮ 
hDlg            dd ?                    ; handle ᭮ 
hGrw            dd ?                    ; handle ᪮ 
htool           dd ?                    ; tool tip handle
hSBIn           dd ?                    ; Sound Blaster handle
hIcon           dd ?                    ;
hvolume         dd ?                    ;
h200            dd ?                    ; Sinusoid
h201            dd ?                    ; Spectral
h202            dd ?                    ; Volume
;h203            dd ?                    ; Start/Stop/Reset

Read            dd ?                    ; ਭ 
Write           dd ?                    ; । 
insico          dd ?                    ; 稪 室
sinfl           dd ?                    ; 1 - 뢮 ᨭᮨ
fftfl           dd ?                    ; 1 - 뢮 ᯥ஬
volfl           dd ?                    ; 1 - 뢮 ஢
caddr           dd ?                    ;  ᪠ ணࠬ
ststre          dd ?                    ; start/stop/reset
sbokfl          dd ?                    ; 1 -  SB  ⥬
lbutfl          dd ?                    ; 1 - left button down

realBuff        dq  Qfft dup (?)        ; ॠ 
imagBuff        dq  Qfft dup (?)        ; ࠪ 
                                        ;
